//	jpegt@CEBhEɓ{ŕ\(GDI+)
//	Visual C++ 2008/2013	32/64bit

#include <windows.h>
#include <gdiplus.h>
#include <tchar.h>

#pragma comment(lib,"gdiplus.lib")

using namespace Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR           gdiToken;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL InitApp(HINSTANCE, WNDPROC, TCHAR*);
BOOL InitInstance(HINSTANCE, TCHAR*, int);
HWND hWnd;


// ŏɌĂяo֐

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst,TCHAR* lpsCmdLine, int nCmdShow){
	MSG msg;
	TCHAR szClassName[] = TEXT("jpgview1");
	GdiplusStartup(&gdiToken, &gdiSI, NULL);
	if (!hPrevInst) {
		if (!InitApp(hCurInst,WndProc, szClassName))    //    EBhENX̓o^
			return FALSE;
	}
	if (!InitInstance(hCurInst, szClassName, nCmdShow)) {    // EBhE̍쐬
		return FALSE;
	}

	while (GetMessage(&msg, NULL, NULL, NULL)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	GdiplusShutdown(gdiToken);

	return (int)msg.wParam;
}

// EBhE쐬//ړ̃bZ[WɂN֐

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp){
	HDC hdc;
	PAINTSTRUCT ps;
	TCHAR* szFile=TEXT("image.jpg");	//	\t@Cw
	static Image* imageP=0;
	switch (msg) {
	case WM_CREATE:{
#ifndef UNICODE
		WCHAR szFileW[MAX_PATH];
		MultiByteToWideChar(932,0,szFile,-1,szFileW,sizeof(szFileW)/sizeof(TCHAR));
		imageP=Bitmap::FromFile(szFileW);
#else
		imageP=Bitmap::FromFile(szFile);
#endif
	}
	break;
	case WM_PAINT: {       // EBhE̕`悪KvȏꍇɌĂяoB
		hdc = BeginPaint(hWnd, &ps);
		Graphics MyGraphics(hdc);
		MyGraphics.DrawImage(imageP,0,0);
		MyGraphics.~Graphics();
		EndPaint(hWnd, &ps);
		break;
	}
    case WM_DESTROY:    // EBhEꍇɌĂяoB
		imageP->~Image();
		PostQuitMessage(0);
		break;
    default:
		return (DefWindowProc(hWnd, msg, wp, lp));
    }
	return 0L;
}

//     EBhENX̓o^@P񂵂Ă΂Ȃ̂Ɋ֐Ă̂́AEBhEQĂяoꍇ
//  ̊֐ėpł邩łB

BOOL InitApp(HINSTANCE hInst,WNDPROC WndProc,TCHAR* szClassName){
	WNDCLASS wc;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = szClassName;
	return (RegisterClass(&wc));
}

//     EBhE̍쐬@P񂵂Ă΂Ȃ̂Ɋ֐Ă̂́AEBhEQĂяoꍇ
//  ̊֐ėpł邩łB

BOOL InitInstance(HINSTANCE hInst, TCHAR* szClassName, int nCmdShow){
	hWnd = CreateWindow(szClassName,
		szClassName,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInst,
		NULL);
	if (!hWnd)
		return FALSE;
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}
